<?
/***************************************************************************
 *							   newsfeed_mod.php
 *                            -------------------
 *   begin                : Monday, April 08, 2002
 *   copyright            : (C) 2002 ashben (www.ashben.net / eServicesHub.com)
 *   email                : phpbb@broid.com
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   Visit www.eServicesHub.com for a live demo. If you like this mod, then
 *   please register at the eSH forums and join our community. Thanks!
 *
 ***************************************************************************/

		//
		// check if we were called directly
		//
		if ( !defined('IN_PHPBB') )
		{
			die("Hacking attempt");
		}

		// Cache duration in seconds. The cache will be updated with a live feed after the specified time
		$cachetimeinseconds=1800;

		// Location to the raw news cache file
		$cachefile="newscache/newscache.txt";

		// Location to the formatted news cache file (used by phpBB)
		$newsfile="newscache/newsindex.htm";

		// News feed URL. Please select your category from http://w.moreover.com/categories/category_list_xml.html
		$xmlfile = "http://p.moreover.com/cgi-local/page?c=Top%20internet%20stories&o=xml";


		$current_time=split(" ",microtime(),2);

		$newsfeedtext = "";

		if((!file_exists($cachefile) || (!filesize($cachefile)) || ($current_time[1]-filemtime($cachefile)>$cachetimeinseconds))){

			// Step 1 - Caching Routine

			if (($file = @fopen($xmlfile, "r"))) {

				$fpwrite = fopen($cachefile, "w");

				$line="";
				while ((!feof($file))) {
					$line = fgets($file, 1024);
					fputs($fpwrite,$line);
				}

				fclose($file);
				fclose($fpwrite);


				// Step 2 - XML Parsing and Content Rendering Routine

				$depth = array();
				$content = array();
				$curtag = "";
				$newsbuffer = "";
				$headline_count = 1;

				function startElement($parser, $name, $attrs) {
				    global $depth;
				    global $curtag;

				    $curtag = $name;
				    $depth[$parser]++;
				}

				function endElement($parser, $name) {
				    global $depth;
				    global $curtag;
				    global $content;
				    global $newsbuffer;
				    global $headline_count;

				    $curtag = "";
				    $depth[$parser]--;
				    
				    if (strtoupper($name) == "ARTICLE" && $headline_count < 11) {
						$newsbuffer .= "<a href='" . $content[0] . "' target='_blank'>" . $content[1] . "</a><br>" . $content[2] . " - " . $content[3] . "\n<br>\n<br>\n";
						$headline_count++;
				    }
				}

				function characterData($parser, $data) {
					global $curtag;
					global $content;
					switch (strtoupper($curtag)) {
					case "URL":
						$content[0] = $data;
						break;
					case "HEADLINE_TEXT":
						$content[1] = $data;
						break;
					case "SOURCE":
						$content[2] = $data;
						break;
					case "HARVEST_TIME":
						$content[3] = $data;
						break;
					}
				}

				if (($fp = @fopen($cachefile, "r"))) {

					$xml_parser = xml_parser_create();
					xml_set_element_handler($xml_parser, "startElement", "endElement");
					xml_set_character_data_handler($xml_parser, "characterData");

					$newsbuffer = "";
					while ($data = fread($fp, filesize($cachefile))) {
						if (!xml_parse($xml_parser, $data, feof($fp))) {
							//error
						}
					}
					xml_parser_free($xml_parser);
					fclose($fp);


					// Step 3 - Generate HTML

					$fpwrite = fopen($newsfile, "w");
					fputs($fpwrite,$newsbuffer);
					fclose($fpwrite);

					$newsfeedtext .= "<!-- NewsCache Updated //-->\n\n";

				} else {

					$newsfeedtext .= "<!-- Error/1 - NewsCache Used //-->\n\n";

				}

			} else {

				$newsfeedtext .= "<!-- Error/2 - NewsCache Used //-->\n\n";

			}

		} else {

			$newsfeedtext .= "<!-- NewsCache Used //-->\n\n";

		}


		if (file_exists($newsfile))
			$newsfeedtext .= implode ('', file($newsfile));
		else
			$newsfeedtext .= "Unavailable.";

		$newsfeedtext .= "\n\n";

?>